; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; Timer 0+1+2 berlauf-Int aktivieren (Timer/Counter Interrupt Mask)			
;																				
TIMER_AKTIVIEREN:
	ldi temp,(0<<OCIE2)|(0<<TOIE2)|(0<<TICIE1)|(0<<OCIE1A)|(0<<OCIE1B)|(0<<TOIE1)|(1<<TOIE0)
	out TIMSK,temp       
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; TIMER0 (8Bit) Vorteiler														
;																				
; CS02 CS01 CS00 	Description													
;	0 	0 	0 		No clock source (Timer/Counter stopped).					
;	0 	0 	1 		clkI/O/		(No prescaling)									
;	0 	1 	0 		clkI/O/8 	(From prescaler)								
; *	0 	1 	1 		clkI/O/64 	(From prescaler)								
; 	1 	0 	0 		clkI/O/256 	(From prescaler)								
; 	1 	0 	1 		clkI/O/1024 (From prescaler)								
;	1 	1 	0 		External clock source on T0 pin. Clock on falling edge.		
;	1 	1 	1 		External clock source on T0 pin. Clock on rising edge.		
TIMER0_INITIALISIERUNG_1ms:
.equ TIMERWERT0	=256-50		; 50;(2 hoch 8  minus...)	
	ldi temp,(0<<CS02)|(1<<CS01)|(1<<CS00)
	OUT TCCR0,temp

	ldi temp, TIMERWERT0	; TIMER0 Startwert		
	mov TIMER0,temp
	out TCNT0,TIMER0
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TIM0_OVF:
	push TEMP		    ; Sichern von "TEMP" im Stack			
	in	 TEMP,SREG		; Einlesen des SREG 					
	push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)	
	push ZL				; ZL sichern							
	push ZH				; ZH sichern							
;-------------------------------------------------------------------------------
	out TCNT0,TIMER0
;-------------------------------------------------------------------------------
; TASTEN																		
	LDS temp,(adr_TASTE)
	tst temp
	brne TIM0_FERTIG

	in temp,PIND
	com temp
	andi temp,0b00001100
	tst temp
	breq TIM0_FERTIG
	STS(adr_TASTE),temp		; save	

	STS(adr_DIGIT7),NULL
	STS(adr_DIGIT6),NULL
	STS(adr_DIGIT5),NULL
	STS(adr_DIGIT4),NULL

	STS(adr_DIGIT3),NULL
	STS(adr_DIGIT2),NULL
	STS(adr_DIGIT1),NULL
	STS(adr_DIGIT0),NULL

	GRUEN_OFF
	GELB_OFF
	ROT_OFF
	rcall BEEP_KURZ
;-------------------------------------------------------------------------------
TIM0_FERTIG:
	rcall LED			; LED-DISPLAY							
	pop ZH				; ZH wiederherstellen					
	pop ZL				; ZH wiederherstellen					
	pop	TEMP			; LESEN von SREG vom STACK (KOPIE)		
	out	SREG,TEMP		; Wiederherstellen von SREG				
	pop	TEMP			; Wiederherstellen von "TEMP" 			
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################


